{% extends "layout.html" %}
{% block title %}Settings{% endblock %}
{% block section %}Settings{% endblock %}
{% block head %}
{{ super() }}
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.16/css/dataTables.bootstrap.min.css">
    <style type="text/css">
        @keyframes spinner {
          to {transform: rotate(360deg);}
        }
        .spinner:before {
          content: '';
          box-sizing: border-box;
          position: absolute;
          top: 50%;
          left: 50%;
          width: 20px;
          height: 20px;
          margin-top: -10px;
          margin-left: -10px;
          border-radius: 50%;
          border: 2px solid #ccc;
          border-top-color: #333;
          animation: spinner .6s linear infinite;
        }
    </style>
{% endblock %}
{% block content %}
      <!-- Default box -->
      <div class="box">
        <div class="box-header with-border">
          <h3 class="box-title">Devices</h3>
            <a href="#" data-toggle="modal" data-target="#scan-devices" class="btn btn-sm bg-{{ current_app.config.APPLICATION_SKIN_COLOR }} btn-flat pull-right"> Search Bluetooth Devices</a>
        </div>
        <div class="box-body">
          <div class="row">
            <div class="col-md-6">
              <div class="box">
                <div class="box-header with-border">
                  <h3 class="box-title">Mijia Sensors</h3>
                </div>
                <div class="box-body">
                  <div class="table-responsive">
                    <table class="table no-margin">
                      <thead>
                        <tr>
                          <th>Sensor</th>
                          <th>Address</th>
                          <th></th>
                        </tr>
                      </thead>
                      <tbody>
                        {% for sensor in mijia_sensors %}
                          <tr data-record-id="mijia-{{ sensor.id }}">
                            <td>{{ sensor.name }}</td>
                            <td>{{ sensor.address }}</td>
                            <td><a href="#" data-record-id="{{ sensor.id }}" data-record-source="sensors"
                                   data-record-name="mijia" data-record-title="mijia sensor {{ sensor.name }}"
                                   data-toggle="modal" data-target="#confirm-delete">delete</a>
                            </td>
                          </tr>
                        {% endfor %}
                      </tbody>
                    </table>
                  </div>
                </div>
                <!-- /.box-body -->
                <div class="box-footer">
                  <a href="#" data-toggle="modal" data-target="#create-mijia" class="btn btn-sm bg-{{ current_app.config.APPLICATION_SKIN_COLOR }} btn-flat pull-right"> + Create Sensor</a>
                </div>
              </div>

              <div class="box">
                <div class="box-header with-border">
                  <h3 class="box-title">Flora Sensors</h3>
                </div>
                <div class="box-body">
                  <div class="table-responsive">
                    <table class="table no-margin">
                      <thead>
                        <tr>
                          <th>Sensor</th>
                          <th>Address</th>
                          <th></th>
                        </tr>
                      </thead>
                      <tbody>
                        {% for sensor in flora_sensors %}
                          <tr data-record-id="flora-{{ sensor.id }}">
                            <td>{{ sensor.name }}</td>
                            <td>{{ sensor.address }}</td>
                            <td><a href="#" data-record-id="{{ sensor.id }}" data-record-source="sensors"
                                   data-record-name="flora" data-record-title="flora sensor {{ sensor.name }}"
                                   data-toggle="modal" data-target="#confirm-delete">delete</a>
                            </td>
                          </tr>
                        {% endfor %}
                      </tbody>
                    </table>
                  </div>
                </div>
                <!-- /.box-body -->
                <div class="box-footer">
                  <a href="#" data-toggle="modal" data-target="#create-flora" class="btn btn-sm bg-{{ current_app.config.APPLICATION_SKIN_COLOR }} btn-flat pull-right"> + Create Sensor</a>
                </div>
              </div>
            </div>
            <!-- /.col -->
            <div class="col-md-6">
              <div class="box">
                <div class="box-header with-border">
                  <h3 class="box-title">Relays</h3>
                </div>
                <div class="box-body">
                  <div class="table-responsive">
                    <table class="table no-margin">
                      <thead>
                        <tr>
                          <th>Relay</th>
                          <th>Pin</th>
                        </tr>
                      </thead>
                      <tbody>
                        {% for relay in relays %}
                          <tr >
                            <td>{{ relay.name }}</td>
                            <td>{{ relay.pin }}</td>
                          </tr>
                        {% endfor %}
                      </tbody>
                    </table>
                  </div>
                </div>
                <!-- /.box-body -->
                <div class="box-footer">
                  <a href="/manager/user/create/new" class="btn btn-sm bg-{{ current_app.config.APPLICATION_SKIN_COLOR }} btn-flat pull-right"> + Create Relay</a>
                </div>
              </div>
              <div class="box">
                <div class="box-header with-border">
                  <h3 class="box-title">Cameras</h3>
                </div>
                <div class="box-body">
                  <div class="table-responsive">
                    <table class="table no-margin">
                      <thead>
                        <tr>
                          <th>Camera</th>
                          <th>Address</th>
                        </tr>
                      </thead>
                      <tbody>
                        {% for camera in cameras %}
                          <tr>
                            <td>{{ camera.name }}</td>
                            <td>{{ camera.address }}</td>
                          </tr>
                        {% endfor %}
                      </tbody>
                    </table>
                  </div>
                </div>
                <!-- /.box-body -->
                <div class="box-footer">
                  <a href="/manager/user/create/new" class="btn btn-sm bg-{{ current_app.config.APPLICATION_SKIN_COLOR }} btn-flat pull-right"> + Create Camera</a>
                </div>
              </div>
            </div>
            <!-- /.col -->
          </div>
        </div>
    </div>
{% endblock %}

{% block footer %}
{{ super() }}
    <div class="modal fade" id="create-mijia" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true">
        <div class="modal-dialog">
            <div class="modal-content">
                <div class="modal-header">
                    <button type="button" class="close" data-dismiss="modal" aria-hidden="true">×</button>
                    <h4 class="modal-title" id="myModalLabel">New Mijia Sensor</h4>
                </div>
                <form class="form-createJob" action="/sensors/mijia/create" method="post">
                  <input type="hidden" name="csrf_token" value="{{ csrf_token() }}"/>
                    <div class="modal-body">
                      <fieldset class="form-group">
                          <div class="form-row">
                            <div class="form-group col-md-6">
                              <label for="name">Name</label>
                              <input type="text" class="form-control" name="name" id="name" placeholder="Sensor Name">
                            </div>
                            <div class="form-group col-md-6">
                              <label for="address">Address</label>
                              <input type="text" class="form-control" name="address" id="address" placeholder="Sensor Bluetooth Address">
                            </div>
                          </div>
                          <h5><b>Create default checks:</b></h5>
                          <div class="form-row">
                            <div class="form-group col-xs-5">
                              <label for="temperature_operator">Temperature</label>
                              <select name="temperature_operator" id="temperature_operator" class="form-control">
                                <option value="==" selected>Equal to</option>
                                <option value=">">Bigger than</option>
                                <option value="<">Smaller than</option>
                                <option value=">=">Bigger or equal to</option>
                                <option value="<=">Smaller or equal to</option>
                              </select>
                            </div>
                            <div class="form-group col-xs-4">
                              <label for="temperature_threshold">Threshold</label>
                              <input type="number" class="form-control" name="temperature_threshold" id="temperature_threshold">
                            </div>
                            <div class="form-group col-xs-3">
                              <label for="temperature_status">Enabled</label>
                              <select name="temperature_status" id="temperature_status" class="form-control">
                                <option value="false" selected>False</option>
                                <option value="true">True</option>
                              </select>
                            </div>
                          </div>
                          <div class="form-row">
                            <div class="form-group col-xs-5">
                              <label for="humidity_operator">Humidity</label>
                              <select name="humidity_operator" id="humidity_operator" class="form-control">
                                <option value="==" selected>Equal to</option>
                                <option value=">">Bigger than</option>
                                <option value="<">Smaller than</option>
                                <option value=">=">Bigger or equal to</option>
                                <option value="<=">Smaller or equal to</option>
                              </select>
                            </div>
                            <div class="form-group col-xs-4">
                              <label for="humidity_threshold">Threshold</label>
                              <input type="number" class="form-control" name="humidity_threshold" id="humidity_threshold">
                            </div>
                            <div class="form-group col-xs-3">
                              <label for="humidity_status">Enabled</label>
                              <select name="humidity_status" id="humidity_status" class="form-control">
                                <option value="false" selected>False</option>
                                <option value="true">True</option>
                              </select>
                            </div>
                          </div>
                          <div class="form-row">
                            <div class="form-group col-xs-5">
                              <label for="battery_operator">Battery</label>
                              <select name="battery_operator" id="battery_operator" class="form-control">
                                <option value="==" selected>Equal to</option>
                                <option value=">">Bigger than</option>
                                <option value="<">Smaller than</option>
                                <option value=">=">Bigger or equal to</option>
                                <option value="<=">Smaller or equal to</option>
                              </select>
                            </div>
                            <div class="form-group col-xs-4">
                              <label for="battery_threshold">Threshold</label>
                              <input type="number" class="form-control" name="battery_threshold" id="battery_threshold">
                            </div>
                            <div class="form-group col-xs-3">
                              <label for="battery_status">Enabled</label>
                              <select name="battery_status" id="battery_status" class="form-control">
                                <option value="false" selected>False</option>
                                <option value="true">True</option>
                              </select>
                            </div>
                          </div>
                      </fieldset>
                    </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-default" data-dismiss="modal">Cancel</button>
                    <button type="submit" class="btn btn-success">Create</button>
                </div>
                </form>
            </div>
        </div>
    </div>

    <div class="modal fade" id="create-flora" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true">
        <div class="modal-dialog">
            <div class="modal-content">
                <div class="modal-header">
                    <button type="button" class="close" data-dismiss="modal" aria-hidden="true">×</button>
                    <h4 class="modal-title" id="myModalLabel">New Flora Sensor</h4>
                </div>
                <form class="form-createJob" action="/sensors/flora/create" method="post">
                  <input type="hidden" name="csrf_token" value="{{ csrf_token() }}"/>
                    <div class="modal-body">
                      <fieldset class="form-group">
                          <div class="form-row">
                            <div class="form-group col-md-6">
                              <label for="name">Name</label>
                              <input type="text" class="form-control" name="name" id="name" placeholder="Sensor Name" required>
                            </div>
                            <div class="form-group col-md-6">
                              <label for="address">Address</label>
                              <input type="text" class="form-control" name="address" id="address" placeholder="Sensor Bluetooth Address" required>
                            </div>
                          </div>
                          <h5><b>Create default checks:</b></h5>
                          <div class="form-row">
                            <div class="form-group col-xs-5">
                              <label for="temperature_operator">Temperature</label>
                              <select name="temperature_operator" id="temperature_operator" class="form-control">
                                <option value="==" selected>Equal to</option>
                                <option value=">">Bigger than</option>
                                <option value="<">Smaller than</option>
                                <option value=">=">Bigger or equal to</option>
                                <option value="<=">Smaller or equal to</option>
                              </select>
                            </div>
                            <div class="form-group col-xs-4">
                              <label for="temperature_threshold">Threshold</label>
                              <input type="number" class="form-control" name="temperature_threshold" id="temperature_threshold">
                            </div>
                            <div class="form-group col-xs-3">
                              <label for="temperature_status">Enabled</label>
                              <select name="temperature_status" id="temperature_status" class="form-control">
                                <option value="false" selected>False</option>
                                <option value="true">True</option>
                              </select>
                            </div>
                          </div>
                          <div class="form-row">
                            <div class="form-group col-xs-5">
                              <label for="moisture_operator">Moisture</label>
                              <select name="moisture_operator" id="moisture_operator" class="form-control">
                                <option value="==" selected>Equal to</option>
                                <option value=">">Bigger than</option>
                                <option value="<">Smaller than</option>
                                <option value=">=">Bigger or equal to</option>
                                <option value="<=">Smaller or equal to</option>
                              </select>
                            </div>
                            <div class="form-group col-xs-4">
                              <label for="moisture_threshold">Threshold</label>
                              <input type="number" class="form-control" name="moisture_threshold" id="moisture_threshold">
                            </div>
                            <div class="form-group col-xs-3">
                              <label for="moisture_status">Enabled</label>
                              <select name="moisture_status" id="moisture_status" class="form-control">
                                <option value="false" selected>False</option>
                                <option value="true">True</option>
                              </select>
                            </div>
                          </div>
                          <div class="form-row">
                            <div class="form-group col-xs-5">
                              <label for="light_operator">Light</label>
                              <select name="light_operator" id="light_operator" class="form-control">
                                <option value="==" selected>Equal to</option>
                                <option value=">">Bigger than</option>
                                <option value="<">Smaller than</option>
                                <option value=">=">Bigger or equal to</option>
                                <option value="<=">Smaller or equal to</option>
                              </select>
                            </div>
                            <div class="form-group col-xs-4">
                              <label for="light_threshold">Threshold</label>
                              <input type="number" class="form-control" name="light_threshold" id="light_threshold">
                            </div>
                            <div class="form-group col-xs-3">
                              <label for="light_status">Enabled</label>
                              <select name="light_status" id="light_status" class="form-control">
                                <option value="false" selected>False</option>
                                <option value="true">True</option>
                              </select>
                            </div>
                          </div>
                          <div class="form-row">
                            <div class="form-group col-xs-5">
                              <label for="conductivity_operator">Conductivity</label>
                              <select name="conductivity_operator" id="conductivity_operator" class="form-control">
                                <option value="==" selected>Equal to</option>
                                <option value=">">Bigger than</option>
                                <option value="<">Smaller than</option>
                                <option value=">=">Bigger or equal to</option>
                                <option value="<=">Smaller or equal to</option>
                              </select>
                            </div>
                            <div class="form-group col-xs-4">
                              <label for="conductivity_threshold">Threshold</label>
                              <input type="number" class="form-control" name="conductivity_threshold" id="conductivity_threshold">
                            </div>
                            <div class="form-group col-xs-3">
                              <label for="conductivity_status">Enabled</label>
                              <select name="conductivity_status" id="conductivity_status" class="form-control">
                                <option value="false" selected>False</option>
                                <option value="true">True</option>
                              </select>
                            </div>
                          </div>
                          <div class="form-row">
                            <div class="form-group col-xs-5">
                              <label for="battery_operator">Battery</label>
                              <select name="battery_operator" id="battery_operator" class="form-control">
                                <option value="==" selected>Equal to</option>
                                <option value=">">Bigger than</option>
                                <option value="<">Smaller than</option>
                                <option value=">=">Bigger or equal to</option>
                                <option value="<=">Smaller or equal to</option>
                              </select>
                            </div>
                            <div class="form-group col-xs-4">
                              <label for="battery_threshold">Threshold</label>
                              <input type="number" class="form-control" name="battery_threshold" id="battery_threshold">
                            </div>
                            <div class="form-group col-xs-3">
                              <label for="battery_status">Enabled</label>
                              <select name="battery_status" id="battery_status" class="form-control">
                                <option value="false" selected>False</option>
                                <option value="true">True</option>
                              </select>
                            </div>
                          </div>
                      </fieldset>
                    </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-default" data-dismiss="modal">Cancel</button>
                    <button type="submit" class="btn btn-success">Create</button>
                </div>
                </form>
            </div>
        </div>
    </div>

    <div class="modal fade" id="confirm-delete" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true">
        <div class="modal-dialog">
            <div class="modal-content">
                <div class="modal-header">
                    <button type="button" class="close" data-dismiss="modal" aria-hidden="true">×</button>
                    <h4 class="modal-title" id="myModalLabel">Confirm Delete</h4>
                </div>
                <div class="modal-body">
                    <p>You are about to delete <b><i class="title"></i></b> this procedure is irreversible.</p>
                    <p>This will delete all associated checks, alerts or schedules.</p>
                    <p>Do you want to proceed?</p>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-default" data-dismiss="modal">Cancel</button>
                    <button type="button" class="btn btn-danger btn-ok">Delete</button>
                </div>
            </div>
        </div>
    </div>

    <div class="modal fade" id="scan-devices" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true">
        <div class="modal-dialog">
            <div class="modal-content">
                <div class="modal-header">
                    <button type="button" class="close" data-dismiss="modal" aria-hidden="true">×</button>
                    <h4 class="modal-title" id="myModalLabel">Search Bluetooth Devices</h4>
                </div>
                <div class="modal-body">
                    <p>Devices</p>
                    <div id="search-body"></div>
                    <div class="table-responsive">
                        <table class="table no-margin hidden" id="scan-table">
                            <tr>
                                <th>Address</th>
                                 <th>Sensor</th>
                            </tr>
                        </table>
                    </div>
                </div>
            </div>
        </div>x
    </div>
{% endblock %}
{% block jquery %}
{{ super() }}
<script>
    $('#confirm-delete').on('click', '.btn-ok', function(e) {
        var $modalDiv = $(e.delegateTarget);
        var source = $(this).data('recordSource');
        var name = $(this).data('recordName');
        var id = $(this).data('recordId');
        var csrf_token = "{{ csrf_token() }}";
        $.ajaxSetup({
          beforeSend: function(xhr, settings) {
            if (!/^(GET|HEAD|OPTIONS|TRACE)$/i.test(settings.type) && !this.crossDomain) {
                xhr.setRequestHeader("X-CSRFToken", csrf_token);
              }
            }
        });
        $.ajax({
          url: '/' + source + '/' + name  + '/delete/' + id,
          type: 'POST',
          success: function(){
            $('[data-record-id=' + name + '-' + id + ']').remove();
            setTimeout(function() {
              $modalDiv.modal('hide');
            }, 100)
          },
          error: function (xhr, ajaxOptions, thrownError){
            //On error, we alert user
            alert(thrownError);
          }
        });
    });
    $('#confirm-delete').on('show.bs.modal', function(e) {
        var data = $(e.relatedTarget).data();
        $('.title', this).text(data.recordTitle);
        $('.btn-ok', this).data('recordId', data.recordId);
        $('.btn-ok', this).data('recordName', data.recordName);
        $('.btn-ok', this).data('recordSource', data.recordSource);
    });

</script>
<script>
    $('#scan-devices').on('show.bs.modal', function(e) {
        var $modalDiv = $('#search-body');
        $modalDiv.addClass('spinner');
        $.ajax({
          url: '/sensors/scan',
          type: 'GET',
          contentType: "application/json; charset=utf-8",
          dataType: "json",
          success: function(data){
            var trHTML = '';
            $modalDiv.removeClass('spinner');
            $.each(data, function (i, item) {

                trHTML += '<tr><td>' + data[i][0] + '</td><td>' + data[i][1] + '</td></tr>';
            });
            var $scanTable = $('#scan-table');
            $scanTable.append(trHTML);
            $scanTable.removeClass('hidden');
          },
          error: function (xhr, ajaxOptions, thrownError){
            //On error, we alert user
            $('#scan-devices').modal('hide');
            alert(thrownError);
          }
        });
    });
    $("#scan-devices").on('hidden.bs.modal', function () {
        $( "#scan-table tbody tr" ).each( function(){
          this.parentNode.removeChild(this);
        });
        $('#scan-table').addClass('hidden')
    });
</script>
{% endblock %}